<?php
/*
	* functions.php
*/

/**
 * Flush rewrite rules for custom post type archive on single activation
 *
 * @since    0.0.1
 */
function pm_fb_hcs_install() {
	flush_rewrite_rules();
}

function pm_fb_hcs_deactivate() {

}

/*
	* Display All Post
*/

function pm_fb_hcs_get_post($entry = null) {
	global $wp_query;
	$args = array(
		'posts_per_page' => -1,
		'post_status' => 'any',
		'post_type' => array('social_question'),
		'orderby' => 'type'
	);
	$query = new WP_Query( $args );
	// The Loop
	while ( $query->have_posts() ) { $query->the_post();
		$selected = ($entry == $query->post->ID ? 'selected' : '');
		print "<option {$selected}  value='{$query->post->ID}'>pid " . $query->post->ID . ': ' . get_the_title( $query->post->ID ) . "</option>";
	}
	// Restore original Post Data
	wp_reset_postdata();
}

/*
	* pm_fb_hcs_post_types
	* Return an array with all public Content-types
*/

function pm_fb_hcs_post_types(){
	$args = array(
	   'public'   => true,
	   'show_ui' => true
	);

	$output = 'names'; // names or objects, note names is the default

	$post_types = get_post_types( $args, $output ); 
	unset($post_types['attachment']);
	
	return $post_types;
}

function pm_fb_hcs_post_types_html() {
	$output = "";
	$post_types = pm_fb_hcs_post_types();
	//get_site_url
	
	$output .= "<select style='display: none;'>";
	foreach($post_types as $k => $v):
	$new_content = get_site_url()."/wp-admin/post-new.php?post_type=".$k;
	$output .= "<option value='' style='display: none;'>-Add to Post Type-</option>";
	$output .= "<option value='{$new_content}'>{$v}</option>";
	endforeach;
	$output .= "</select>";
	
	return $output;
}

/*
	* pm_fb_hcs_settings_fields
	* Fields for Settings
*/
function pm_fb_hcs_setting_fields(){
	$fields = array(
	'facebook' => array(
		'social_name' => __( 'Facebook', 'pm-fb-hcs' ),
		'general_description' => __( 'App Domains should be your sitedomain.com', 'pm-fb-hcs' ),
		'fields' => array(
			'app_id' => array(
				'name' => 'app_id',
				'description' => __( 'Enter your Facebook AppID', 'pm-fb-hcs' ),
				'field' => 'input',
				'type' => 'text',
				'label' => __( 'App Id', 'pm-fb-hcs' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			),
			'app_secret' => array(
				'name' => 'app_secret',
				'description' => __( 'Enter your Facebook Secret Key', 'pm-fb-hcs' ),
				'field' => 'input',
				'type' => 'text',
				'label' => __( 'App Secret', 'pm-fb-hcs' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			),
			'token' => array(
				'name' => 'token',
				'description' => __( 'Access Token', 'pm-fb-hcs' ),
				'field' => 'input',
				'type' => 'hidden',
				'label' => __('Access Token', 'pm-fb-hcs' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => false
			),
			'authorized' => array(
				'name' => 'authorized',
				'description' => __( 'If Social Authorized', 'pm-fb-hcs' ),
				'field' => 'input',
				'type' => 'hidden',
				'label' => __( 'Authorized', 'pm-fb-hcs' ),
				'default' => 0,
				'repeatable' => false,
				'show_add' => false,
				'required' => false
			)
		)
	),
	'settings' => array(
		'social_name' => __( 'Options', 'pm-fb-hcs' ),
		'general_description' => __( 'Additional Options.', 'pm-fb-hcs' ),
		'fields' => array(
			'query_limit' => array(
				'name' => 'query_limit',
				'description' => __( 'Enter limit for number for results. Higher number may slow down the Search.', 'pm-fb-hcs' ),
				'field' => 'input',
				'type' => 'text',
				'label' => __( 'Search Limit', 'pm-fb-hcs' ),
				'default' => 10,
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			)
		)
	),
	);
	
	return $fields;
}

/*
	* pm_pmover_setting_fields
	* Fields for Settings
*/
function pm_fb_hcs_set_field($attr,$social,$opt){
	$output = '';
	$values = pm_fb_hcs_setting_fields();
	if($attr == 'name') {
		$output = PM_FB_HCS_SETTINGS_OPTION . "[{$social}]" . "[{$opt}]";
	} elseif($attr == 'id') {
		$output = PM_FB_HCS_SETTINGS_OPTION . "_{$social}" . "_{$opt}";
	} else {
		$output = $values[$social]['fields'][$opt][$attr];
	}
	return $output;
}

/*
	Get Settings URL
*/

function pm_fb_hcs_settings_url() {
	$url = admin_url('admin.php?page=pm_fb_hcs_settings');
	return $url;
}

/*
	* Facebook Initialize
*/

function pm_fb_hcs_facebook_initialize() {
	require_once('libs/facebook/autoload.php');
	$setting_fields = pm_fb_hcs_setting_fields();
	$options = get_option(PM_FB_HCS_SETTINGS_OPTION, array());
	$sn = 'facebook';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	$error = true;
	$fb = '';
	
	if(is_array($creds)) {
		foreach($creds as $key => $cred) {
			if($setting_fields[$sn]['fields'][$key]['required']) {
			$error = (empty($cred) ? true : false );
			if($error) {break;}
			}
		}
	}
	
	if($error){
		//Variables to validate
	} else {
		$_SESSION[$sn.'_app_id'] = (string) $creds['app_id'];
		$_SESSION[$sn.'_app_secret'] = (string) $creds['app_secret'];
		$fb_user_tokken = (isset($creds['token']) ? $creds['token'] : '');
		if(empty($fb_user_tokken) && isset($_SESSION[$sn.'_access_token']) && !empty($_SESSION[$sn.'_access_token'])) {
			
			$options[$sn]['token'] = $_SESSION[$sn.'_access_token'];
			$options[$sn]['authorized'] = 1;
			update_option(PM_FB_HCS_SETTINGS_OPTION, $options);
			$fb_user_tokken = $_SESSION['facebook_access_token'];
			unset($_SESSION['facebook_access_token']);
		}
		
		$fb = new Facebook\Facebook([
		  'app_id' => $creds['app_id'],
		  'app_secret' => $creds['app_secret'],
		  'default_graph_version' => 'v2.4',
		  'default_access_token' => (isset($fb_user_tokken) ? $fb_user_tokken : '')
		]);
	}
	return $fb;
}

/*
	* Facebook Connect
*/

function pm_fb_hcs_facebook_connect() {
	$fb = pm_fb_hcs_facebook_initialize();
	
	$setting_fields = pm_fb_hcs_setting_fields();
	$options = get_option(PM_FB_HCS_SETTINGS_OPTION, array());
	$sn = 'facebook';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	
	if($fb):
		try {
			$current_user = $fb->get('/me');
			$user = $current_user->getGraphUser();
			?>
			<h3><?php print $setting_fields[$sn]['social_name']; ?></h3>
			<p><strong><?php esc_html(_e( 'Connected as: ', 'pm-fb-hcs' )); ?></strong> <?php print $user['name']; ?></p>
			<?php pm_fb_hcs_facebook_logout(); ?>
			<?php
		} catch(Facebook\Exceptions\FacebookResponseException $e) {
		//echo 'Graph returned an error: ' . $e->getMessage();
			$helper = $fb->getRedirectLoginHelper();
			$permissions = ['manage_pages','publish_actions','publish_pages','user_managed_groups']; // optional
			$loginUrl = $helper->getLoginUrl(PM_FB_HCS_DIR.'modules/libs/login/facebook-login.php', $permissions);
			$image_url = PM_FB_HCS_DIR.'modules/src/images/login-'.$sn.'.png';
			echo '<p class="pm_fb_hcs_login_facebook"><a href="' . $loginUrl . '"><img src="'.$image_url.'" height="30" /></a></p>';
		} catch(Facebook\Exceptions\FacebookSDKException $e) {
			echo esc_html(sprintf(__('Facebook SDK returned an error: %s', 'pm-fb-hcs'),$e->getMessage()));
		}
	endif; //End $fb
}

/*
	* Facebook Logout
*/

function pm_fb_hcs_facebook_logout() {
	$sn = 'facebook';
	$logoutUrl = $_SERVER['REQUEST_URI']."&social={$sn}&logout=yes";
	$settings_url = pm_fb_hcs_settings_url();
	if(isset($_GET['logout']) && $_GET['logout'] == 'yes' && $_GET['social'] == $sn) {
	//$fb->get('/me/permissions','DELETE');
	$options = get_option(PM_FB_HCS_SETTINGS_OPTION, array());
	$options[$sn]['token'] = '';
	$options[$sn]['authorized'] = 0;
	update_option(PM_FB_HCS_SETTINGS_OPTION, $options);
	print $admin_url;
	echo "<script> window.location='{$settings_url}'; </script> ";
	}
	
	echo '<p><a href="' . $logoutUrl . '">'. esc_html(__( 'Logout Facebook: ', 'pm-fb-hcs' )) .'</a></p>';
}

/*
	* Facebook Logged-in Status
*/

function pm_fb_hcs_login_status() {
	$status = false;
	$fb = pm_fb_hcs_facebook_initialize();
	
	$setting_fields = pm_fb_hcs_setting_fields();
	$options = get_option(PM_FB_HCS_SETTINGS_OPTION, array());
	$sn = 'facebook';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	
	if($fb):
		try {
			$current_user = $fb->get('/me');
			$status = true;
		} catch(Facebook\Exceptions\FacebookResponseException $e) {
		} catch(Facebook\Exceptions\FacebookSDKException $e) {
			
		}
	endif; //End $fb
	
	return $status;
}

/*
	* CURL contents from graph API
*/

function pm_fb_hcs_api_call($query, $token) {
		$ch = curl_init();
		$api_url = 'https://graph.facebook.com/v2.6/';
		$url = $api_url.$query.'&access_token='.$token;
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		//curl_setopt($ch,CURLOPT_USERAGENT,'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.13) Gecko/20080311 Firefox/2.0.0.13');
		$html = curl_exec($ch);
		$data = curl_exec($ch);
		curl_close($ch);
		$data =  json_decode( $data );
		return $data;
	}

/*
	* Query Results based on selection
*/	

function pm_fb_hcs_get_request_query($data) {
	$request = '';
	
	if( $data['type'] == 'feed' ) {
		$request = "{$data['id']}/feed/?fields=id,message,created_time,link,shares,likes.limit(1).summary(true)&limit={$data['limit']}";
	} elseif( $data['type'] == 'videos' ) {
		$request = "{$data['id']}/videos/?fields=id,created_time,description,source,picture,permalink_url,likes.limit(1).summary(true)&limit={$data['limit']}";
	} elseif( $data['type'] == 'albums' ) {
		$request = "{$data['id']}/albums/?fields=id,name,link,created_time,cover_photo{source},count&limit={$data['limit']}";
	} elseif( $data['type'] == 'photos' ) {
		$request = "{$data['id']}/photos/?fields=id,name,link,created_time,webp_images,likes.limit(1).summary(true)&limit={$data['limit']}";
	}
	return $request;
	
}

/*
	* pm_fb_hcs_get_post_callback
*/

add_action( 'wp_ajax_pm_fb_hcs_get_post', 'pm_fb_hcs_get_post_callback' );

function pm_fb_hcs_get_post_callback() {
	$empty_message = esc_html( __('Results are empty. please try other keywords', 'pm-fb-hcs') );
	$hcs_results = array();
	$tabid = intval( $_POST['tabid'] );
	$id = intval( $_POST['fid'] );
	$name = trim( $_POST['name'] );
	$type = trim( $_POST['type'] );
	$custom_limit = (isset($_POST['limit']) ? intval( $_POST['limit'] ) : '' );
	
	$options = get_option(PM_FB_HCS_SETTINGS_OPTION, array());
	$access_token = $options['facebook']['token'];
	$limit = $options['settings']['query_limit'];
	$data = array();
	$data['access_token'] = $access_token;
	$data['limit'] = (empty($custom_limit) ? $limit : $custom_limit);
	$data['id'] = $id;
	$data['type'] = $type;
	//$hcs_results = pm_fb_hcs_api_call($search_query, $access_token);
	//print json_encode($hcs_results);
	$from_id = $tabid;
	$search_query = pm_fb_hcs_get_request_query($data);
	$hcs_results = pm_fb_hcs_api_call($search_query, $access_token);
	?>
	<h2 class="selected-name"><?php print $name; ?></h2>
	<ul id="tab_selections">
		<li id="tab-feed" ><a class="tab-link selected" href="#" data-type="feed" data-id="<?php print $tabid; ?>"><?php esc_html(_e('Feeds','pm-fb-hcs')); ?></a></li>
		<li id="tab-albums" ><a class="tab-link" href="#" data-type="albums" data-id="<?php print $tabid; ?>"><?php esc_html(_e('Albums','pm-fb-hcs')); ?></a></li>
		<li id="tab-videos" ><a class="tab-link" href="#" data-type="videos" data-id="<?php print $tabid; ?>"><?php esc_html(_e('Videos','pm-fb-hcs')); ?></a></li>
	</ul>
	<?php if( empty($hcs_results->data) ): ?>
		<h4><?php print $empty_message; ?></h4>
	<?php endif; ?>
	<?php if( !empty($hcs_results->data) ): 
			if( $data['type'] == 'feed' ):
				print pm_fb_hcs_format_result_feed($hcs_results);
			elseif( $data['type'] == 'videos' ):
				print pm_fb_hcs_format_result_videos($hcs_results);
			elseif( $data['type'] == 'albums' ):
				print pm_fb_hcs_format_result_albums($hcs_results, $from_id);
			elseif( $data['type'] == 'photos' ):
				print pm_fb_hcs_format_result_photos($hcs_results);
			endif;
	endif; ?>
	
	
	
	
	<?php
	die(); // this is required to return a proper result
}

/*
	* Format Result
*/

function pm_fb_hcs_format_result_groups($hcs_results) {
	?>
	<?php pm_fb_hcs_display_sorting(true,false); ?>
	<table class="form-table">
		<thead>
		<tr>
			<th><?php esc_html(_e('Profile Image','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Name &amp; Info','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Privacy','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Actions','pm-fb-hcs')); ?></th>
		</tr>
		</thead>
		<tbody>
		<?php 
			$number = 0;
			foreach($hcs_results->data as $fbdata ): $number++; ?>
			<tr class="row-<?php print $number;  ?>" data-name="<?php print $fbdata->name; ?>" data-likes="<?php print $fbdata->fan_count; ?>">
				<td>
				<?php 
					$picture = $fbdata->picture->data->url;
				?>
				<img src="<?php print $picture; ?>" />
				</td>
				<td class="post_content_class">
					<a href="https://www.facebook.com/groups/<?php print $fbdata->id; ?>" target="_blank" title="<?php print $fbdata->name; ?>"><?php print $fbdata->name; ?></a>
					<p><?php print $fbdata->about; ?></p>
					<div class="post_content_wrapper" style="display: none;">
						<?php 
							$content = "";
							$content .= "<h3><a href='{$fbdata->link}' target='_blank' title='{$fbdata->name}'>{$fbdata->name}</a></h3>";
							$content .= "<p><img src='{$picture}' /></p>";
							print urlencode($content);
						?>
					</div>
				</td>
				<td class="privacy-<?php print strtolower($fbdata->privacy); ?>"><?php print $fbdata->privacy; ?></td>
				<td>
					<?php 
						$page_url = "https://www.facebook.com/groups/".$fbdata->id;
						$raw_url = rawurlencode($page_url);
						$share_link = "https://www.facebook.com/sharer/sharer.php?u=".$raw_url
					?>
					<?php if(strtolower($fbdata->privacy) == 'open'): ?>
					<div class="icons_inline"><span class="fb-hcs-btn select"><a href="#" data-name="<?php print $fbdata->name; ?>" data-id="<?php print $fbdata->id; ?>" title="<?php esc_html(_e('View Content','pm-fb-hcs')); ?>"><i class="fa fa-search" aria-hidden="true"></i></a></span></div>
					<?php else: ?>
					<span>-</span>
					<?php endif; ?>
				</td>
			</tr>
		<?php endforeach; ?>
		</tbody>
	</table>
	<?php
}

function pm_fb_hcs_format_result_pages($hcs_results) {
	?>
	<?php pm_fb_hcs_display_sorting(); ?>
	<table class="form-table">
		<thead>
		<tr>
			<th><?php esc_html(_e('Profile Image','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Name &amp; Info','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Total Likes','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Actions','pm-fb-hcs')); ?></th>
		</tr>
		</thead>
		<tbody>
		<?php 
			$number = 0;
			foreach($hcs_results->data as $fbdata ): $number++; ?>
			<tr class="row-<?php print $number;  ?>" data-name="<?php print $fbdata->name; ?>" data-likes="<?php print $fbdata->fan_count; ?>">
				<td>
				<?php 
					$picture = $fbdata->picture->data->url;
				?>
				<img src="<?php print $picture; ?>" />
				</td>
				<td class="post_content_class">
					<a href="<?php print $fbdata->link; ?>" target="_blank" title="<?php print $fbdata->name; ?>"><?php print $fbdata->name; ?></a>
					<p><?php print $fbdata->about; ?></p>
					<div class="post_content_wrapper" style="display: none;">
						<?php 
							$content = "";
							$content .= "<h3><a href='{$fbdata->link}' target='_blank' title='{$fbdata->name}'>{$fbdata->name}</a></h3>";
							$content .= "<p><img src='{$picture}' /></p>";
							$content .= "<p>{$fbdata->about}</p>";
							print urlencode($content);
						?>
					</div>
				</td>
				<td><?php print number_format($fbdata->fan_count); ?></td>
				<td>
					<?php 
						$page_url = rawurlencode($fbdata->link);
						$share_link = "https://www.facebook.com/sharer/sharer.php?u=".$page_url
					?>
					<div class="icons_inline"><span class="fb-hcs-btn select"><a href="#" data-name="<?php print $fbdata->name; ?>" data-id="<?php print $fbdata->id; ?>" title="<?php esc_html(_e('View Content','pm-fb-hcs')); ?>"><i class="fa fa-search" aria-hidden="true"></i></a></span></div>
					<div class="icons_inline"><span class="fb-hcs-btn share"><a href="<?php print $share_link; ?>" title="<?php esc_html(_e('Share','pm-fb-hcs')); ?>" target="_blank"><i class="fa fa-share-alt-square" aria-hidden="true"></i></a></span></div>
					<div class="icons_inline"><span class="fb-hcs-btn view"><a href="<?php print $fbdata->link; ?>" title="<?php esc_html(_e('View on Facebook','pm-fb-hcs')); ?>" target="_blank"><i class="fa fa-share-square-o" aria-hidden="true"></i></a></span></div>
					<div class="icons_inline publish_content_wrapper" data-class="row-<?php print $number;  ?>">
					<?php print pm_fb_hcs_post_types_html(); ?>
					<span class="fb-hcs-btn publish"><a href="#" data-id="<?php print $fbdata->id; ?>" title="<?php esc_html(_e('Publish','pm-fb-hcs')); ?>"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></a></span></div>
				</td>
			</tr>
		<?php endforeach; ?>
		</tbody>
	</table>
	<?php
}

function pm_fb_hcs_format_result_photos($hcs_results) {
	?>
	<?php pm_fb_hcs_display_sorting(); ?>
	<table class="form-table albums">
		<thead>
		<tr>
			<th><?php esc_html(_e('Photo','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Likes','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Actions','pm-fb-hcs')); ?></th>
		</tr>
		</thead>
		<tbody>
			<?php foreach($hcs_results->data as $fbdata ): $number++; ?>
			<tr class="row-<?php print $number;  ?>" data-name="<?php print $fbdata->name; ?>" data-likes="<?php print (isset($fbdata->likes->summary->total_count) ? $fbdata->likes->summary->total_count : 0); ?>">
				<td>
					<?php 
						$dd = pm_fb_hcs_format_date($fbdata->created_time);
						$photo = $fbdata->webp_images;
					?>
					<div class="photo_wrapper"><img width="400" src="<?php print $photo[0]->source; ?>" /></div>
					<?php if( isset($fbdata->name) ): ?>
					<p><?php print nl2br($fbdata->name); ?></p>
					<?php endif; ?>
					<p class="date-created"><?php print $dd; ?></p>
					<div class="post_content_wrapper" style="display: none;">
						<?php 
							$page_url = $fbdata->link;
							$raw_url = rawurlencode($page_url);
							$share_link = "https://www.facebook.com/sharer/sharer.php?u=".$raw_url;

							$content = "";
							$content .= "<p><a href='{$page_url}' target='_blank'><img src='{$photo[0]->source}' /></a></p>";
							$content .= "<p>".nl2br($fbdata->name)."</p>";
							$content .= "<p><a href='{$page_url}' target='_blank'>View on Facebook</a></p>";
							print urlencode($content);
						?>
					</div>
				</td>
				<td><?php print (isset($fbdata->likes->summary->total_count) ? number_format($fbdata->likes->summary->total_count) : 0); ?></td>
				<td>
					<?php 
						
					?>
					<div class="icons_inline"><span class="fb-hcs-btn share"><a href="<?php print $share_link; ?>" title="<?php esc_html(_e('Share','pm-fb-hcs')); ?>" target="_blank"><i class="fa fa-share-alt-square" aria-hidden="true"></i></a></span></div>
					<div class="icons_inline"><span class="fb-hcs-btn view"><a href="<?php print $page_url; ?>" title="<?php esc_html(_e('View on Facebook','pm-fb-hcs')); ?>" target="_blank"><i class="fa fa-share-square-o" aria-hidden="true"></i></a></span></div>
					<div class="icons_inline publish_content_wrapper" data-class="row-<?php print $number;  ?>"><?php print pm_fb_hcs_post_types_html(); ?><span class="fb-hcs-btn publish"><a href="#" data-id="<?php print $fbdata->id; ?>" title="<?php esc_html(_e('Publish','pm-fb-hcs')); ?>"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></a></span></div>
				</td>
			</tr>
			<?php endforeach; ?>
		</tbody>
	</table>
	<?php if(isset($hcs_results->paging->next)): ?>
	
	<?php endif; ?>
	<?php
}

function pm_fb_hcs_format_result_albums($hcs_results, $from_id) {
	?>
	<?php pm_fb_hcs_display_sorting(true,false); ?>
	<table class="form-table albums">
		<thead>
		<tr>
			<th><?php esc_html(_e('Albums','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Actions','pm-fb-hcs')); ?></th>
		</tr>
		</thead>
		<tbody>
			<?php foreach($hcs_results->data as $fbdata ): $number ++; ?>
			<tr class="row-<?php print $number;  ?>" data-name="<?php print $fbdata->name; ?>" data-likes="">
				<td>
					<?php 
						$dd = pm_fb_hcs_format_date($fbdata->created_time);
						$album = $fbdata->cover_photo;
					?>
					<div class="photo_wrapper"><img width="450" src="<?php print $album->source; ?>" /></div>
					<h4 class="album-title"><?php print nl2br($fbdata->name); ?> (<?php print $fbdata->count; ?> <?php esc_html(_e('photos','pm-fb-hcs')); ?>)</h4>
					<p class="date-created"><?php print $dd; ?></p>
				</td>
				<td>
					<?php 
						$page_url = $fbdata->link;
						$raw_url = rawurlencode($page_url);
						$share_link = "https://www.facebook.com/sharer/sharer.php?u=".$raw_url;
					?>
					<div class="icons_inline"><span class="fb-hcs-btn view_photos"><a href="#" data-name="<?php print $fbdata->name; ?>" data-count="<?php print $fbdata->count; ?>" data-tabid="<?php print $from_id; ?>"  data-id="<?php print $fbdata->id; ?>" title="<?php esc_html(_e('View Photos','pm-fb-hcs')); ?>"><i class="fa fa-search" aria-hidden="true"></i></a></span></div>
					<div class="icons_inline"><span class="fb-hcs-btn share"><a href="<?php print $share_link; ?>" title="<?php esc_html(_e('Share','pm-fb-hcs')); ?>" target="_blank"><i class="fa fa-share-alt-square" aria-hidden="true"></i></a></span></div>
					<div class="icons_inline"><span class="fb-hcs-btn view"><a href="<?php print $page_url; ?>" title="<?php esc_html(_e('View on Facebook','pm-fb-hcs')); ?>" target="_blank"><i class="fa fa-share-square-o" aria-hidden="true"></i></a></span></div>
				</td>
			</tr>
			<?php endforeach; ?>
		</tbody>
	</table>
	<?php
}


function pm_fb_hcs_format_result_videos($hcs_results) {
	?>
	<?php pm_fb_hcs_display_sorting(true,true); ?>
	<table class="form-table videos">
		<thead>
		<tr>
			<th><?php esc_html(_e('Video','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Likes','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Actions','pm-fb-hcs')); ?></th>
		</tr>
		</thead>
		<tbody>
			<?php foreach($hcs_results->data as $fbdata ): $number ++;?>
			<tr class="row-<?php print $number;  ?>" data-name="<?php print $fbdata->description; ?>" data-likes="<?php print (isset($fbdata->likes->summary->total_count) ? $fbdata->likes->summary->total_count : 0); ?>">
				<td>
					<?php 
						$dd = pm_fb_hcs_format_date($fbdata->created_time);
					?>
					<p><?php print nl2br($fbdata->description); ?></p>
					<div class="video_link_wrapper"><a href="#" data-video="<?php print $fbdata->source; ?>"><img width="450" src="<?php print $fbdata->picture; ?>" /></a></div>
					<p><?php esc_html(_e('Click image to play','pm-fb-hcs')); ?></p>
					<p class="date-created"><?php print $dd; ?></p>
					<div class="post_content_wrapper" style="display: none;">
						<?php 
							$page_url = 'https://www.facebook.com'.$fbdata->permalink_url;
							$raw_url = rawurlencode($page_url);
							$share_link = "https://www.facebook.com/sharer/sharer.php?u=".$raw_url;

							$content = "<iframe src='{$fbdata->source}' width='100%'></iframe>";
							$content .= "<p>".nl2br($fbdata->description)."</p>";
							$content .= "<p><a href='{$page_url}' target='_blank'>View on Facebook</a></p>";
							print urlencode($content);
						?>
					</div>
				</td>
				<td><?php print (isset($fbdata->likes->summary->total_count) ? number_format($fbdata->likes->summary->total_count) : 0); ?></td>
				<td>
					<?php 
						
					?>
					<div class="icons_inline"><span class="fb-hcs-btn share"><a href="<?php print $share_link; ?>" title="<?php esc_html(_e('Share','pm-fb-hcs')); ?>" target="_blank"><i class="fa fa-share-alt-square" aria-hidden="true"></i></a></span></div>
					<div class="icons_inline"><span class="fb-hcs-btn view"><a href="<?php print $page_url; ?>" title="<?php esc_html(_e('View on Facebook','pm-fb-hcs')); ?>" target="_blank"><i class="fa fa-share-square-o" aria-hidden="true"></i></a></span></div>
					<div class="icons_inline publish_content_wrapper" data-class="row-<?php print $number;  ?>"><?php print pm_fb_hcs_post_types_html(); ?><span class="fb-hcs-btn publish"><a href="#" data-id="<?php print $fbdata->id; ?>" title="<?php esc_html(_e('Publish','pm-fb-hcs')); ?>"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></a></span></div>
				</td>
			</tr>
			<?php endforeach; ?>
		</tbody>
	</table>
	<?php
}


function pm_fb_hcs_format_result_feed($hcs_results) {
	?>
	<?php pm_fb_hcs_display_sorting(false,true,true); ?>
	<table class="form-table feed">
		<thead>
		<tr>
			<th><?php esc_html(_e('Post','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Likes','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Shares','pm-fb-hcs')); ?></th>
			<th><?php esc_html(_e('Actions','pm-fb-hcs')); ?></th>
		</tr>
		</thead>
		<tbody>
			<?php foreach($hcs_results->data as $fbdata ): $number ++; ?>
			<tr class="row-<?php print $number;  ?>" data-name="" data-shares="<?php print (isset($fbdata->shares->count) ? $fbdata->likes->summary->total_count : 0); ?>" data-likes="<?php print (isset($fbdata->likes->summary->total_count) ? $fbdata->likes->summary->total_count : 0); ?>">
				<td>
					<?php 
						$dd = pm_fb_hcs_format_date($fbdata->created_time);
					?>
					<p><?php print nl2br($fbdata->message); ?></p>
					<p class="date-created"><?php print $dd; ?></p>
					
					<div class="post_content_wrapper" style="display: none;">
						<?php 							
							$content = '';
							$content .= "<p>".nl2br($fbdata->message)."</p>";
							$content .= "<p><a href='{$fbdata->link}' target='_blank'>View External Link</a></p>";
							print urlencode($content);
						?>
					</div>
					
				</td>
				<td><?php print (isset($fbdata->likes->summary->total_count) ? number_format($fbdata->likes->summary->total_count) : 0); ?></td>
				<td><?php print (isset($fbdata->shares->count) ? number_format($fbdata->shares->count) : 0); ?></td>
				<td>
					<?php 
						$page_url = rawurlencode($fbdata->link);
						$share_link = "https://www.facebook.com/sharer/sharer.php?u=".$page_url;
					?>
					<div class="icons_inline"><span class="fb-hcs-btn share"><a href="<?php print $share_link; ?>" title="<?php esc_html(_e('Share','pm-fb-hcs')); ?>" target="_blank"><i class="fa fa-share-alt-square" aria-hidden="true"></i></a></span></div>
					<div class="icons_inline"><span class="fb-hcs-btn view"><a href="<?php print $fbdata->link; ?>" title="<?php esc_html(_e('View on Facebook','pm-fb-hcs')); ?>" target="_blank"><i class="fa fa-share-square-o" aria-hidden="true"></i></a></span></div>
					<div class="icons_inline publish_content_wrapper" data-class="row-<?php print $number;  ?>"><?php print pm_fb_hcs_post_types_html(); ?><span class="fb-hcs-btn publish"><a href="#" data-id="<?php print $fbdata->id; ?>" title="<?php esc_html(_e('Publish','pm-fb-hcs')); ?>"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></a></span></div>
				</td>
			</tr>
			<?php endforeach; ?>
		</tbody>
	</table>
	<?php
}

/*
	* Format Facebook Created Time
*/

function pm_fb_hcs_format_date($create_time) {
	$date = DateTime::createFromFormat(DateTime::ISO8601, $create_time);
	$dd =  $date->format('F d, Y H:i');
	return $dd;
}

function pm_fb_hcs_post_new_admin_script( $hook ) {
    if ( 'post-new.php' != $hook ) {
        return;
    }
    wp_enqueue_script( 'pm_fb_hcs_admin_add_html_type', PM_FB_HCS_DIR.'modules/src/js/pm-fb-hcs-add-html-type.js', array('jquery'), PM_FB_HCS_VERSION );
}
add_action( 'admin_enqueue_scripts', 'pm_fb_hcs_post_new_admin_script' );

/*
	** Add To new Post
*/

function pm_fb_hcs_add_content_script($plugin_array) {
	$plugin_array["pm_fb_hcs_admin_add_script"] =  PM_FB_HCS_DIR.'modules/src/js/pm-fb-hcs-add.js';
    return $plugin_array;
}
add_action( 'mce_external_plugins', 'pm_fb_hcs_add_content_script' );

/*
	* Display Sorting
*/

function pm_fb_hcs_display_sorting($name = true, $likes = true, $shares = false) { ?>
	<div id="result_sorting">
		<label for="hcs_sort_results"><strong><?php esc_html(_e('Sort Results by: ','pm-fb-hcs')); ?></strong></label>
		<select id="hcs_sort_results" name="hcs_sort_results">
			<option value="" style="display: none;">--</option>
			<?php if($name): ?>
			<option value="name-asc" data-type="name" data-sort="asc"><?php esc_html(_e('Name (ASC)','pm-fb-hcs')); ?> &uarr;</option>
			<option value="name-desc" data-type="name" data-sort="desc"><?php esc_html(_e('Name(DESC)','pm-fb-hcs')); ?> &darr;</option>
			<?php endif; ?>
			<?php if($likes): ?>
			<option value="likes-asc" data-type="likes" data-sort="asc"><?php esc_html(_e('Likes (ASC)','pm-fb-hcs')); ?> &uarr;</option>
			<option value="likes-desc" data-type="likes" data-sort="desc"><?php esc_html(_e('Likes (DESC)','pm-fb-hcs')); ?> &darr;</option>
			<?php endif; ?>
			<?php if($shares): ?>
			<option value="shares-asc" data-type="shares" data-sort="asc"><?php esc_html(_e('Shares (ASC)','pm-fb-hcs')); ?> &uarr;</option>
			<option value="shares-desc" data-type="shares" data-sort="desc"><?php esc_html(_e('Shares (DESC)','pm-fb-hcs')); ?> &darr;</option>
			<?php endif; ?>
		</select>
	</div>
<?php
}

