<?php 
add_action('init', 'pm_fb_hcs_start_session', 1);
function pm_fb_hcs_start_session() {
    if(!session_id()) {
        session_start();
    }
	
	$_SESSION['pm_fb_hcs_settings_url'] = pm_fb_hcs_settings_url();
}

/*
	* pm_fb_hcs_adminscripts
	* Enq Scripts and StyleSheets
	* FontAwesome: //maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css

*/

function pm_fb_hcs_register_settings() {
	add_menu_page(esc_html(__( 'Facebook HCS Settings', 'pm-fb-hcs' )), esc_html(__( 'Facebook HCS Settings', 'pm-fb-hcs' )), 'manage_options', 'pm_fb_hcs_settings', 'pm_fb_hcs_settings_page', '' );
	add_action( 'admin_init', 'pm_fb_hcs_settings_register_callback' );
}
add_action( 'admin_menu', 'pm_fb_hcs_register_settings' );


/*
	* pm_fb_hcs_settings_register_callback
*/

function pm_fb_hcs_settings_register_callback() {
	//register our settings
	register_setting( 'pm-fb-hcs-settings-group', PM_FB_HCS_SETTINGS_OPTION, 'pm_fb_hcs_settings_validate');
}

/*
	* pm_fb_hcs_settings_validate
*/

function pm_fb_hcs_settings_validate($input) {
	$array = array();
	foreach($input as $key => $values) {
		if(is_array($input[$key])) {
			//$input[$key] = array_filter($input[$key]);
			if($input[$key]) {
				//$values = array_filter($values);
				if(is_array($values)){
					foreach($values as $vkey => $value) {
						$array[$key][$vkey] = wp_strip_all_tags($value,true);
					}
				}
			}
			
		}
	}
	return $array;
}


/*
	* Settings Page for Facebook Hot Content Seeker
*/


function pm_fb_hcs_settings_page() {
	pm_fb_hcs_facebook_connect();
	$setting_fields = pm_fb_hcs_setting_fields();
	$options = get_option(PM_FB_HCS_SETTINGS_OPTION, array());
	
	wp_enqueue_style( 'pm-font-awesome', 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.6.3/css/font-awesome.min.css', '', PM_FB_HCS_VERSION, 'all' );
	wp_enqueue_style( 'pm-fb-hcs-style', PM_FB_HCS_DIR.'modules/src/css/pm-fb-hcs.css', '', PM_FB_HCS_VERSION, 'all' );
	wp_enqueue_script( 'pm-fb-hcs-admin-script', PM_FB_HCS_DIR.'modules/src/js/pm-fb-hcs.js', array('jquery'), PM_FB_HCS_VERSION, true );
	wp_enqueue_script( 'pm-fb-hcs-tiny-sort-script', 'https://cdnjs.cloudflare.com/ajax/libs/tinysort/2.3.6/tinysort.min.js', array('jquery'), '2.3.6', true );
	$myAjax = array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) );
	wp_localize_script( 'pm-fb-hcs-admin-script', 'myAjax', $myAjax);
	?>
	
	<div id="fb_hcs_settings" class="wrap">
		<form id="pm_fb_hcs_form" class="pm_fb_hcs_form" action="options.php" method='post'>
			<?php settings_fields( 'pm-fb-hcs-settings-group' ); ?>
			<?php do_settings_sections( 'pm-fb-hcs-settings-group' ); ?>
			<?php 
			foreach($setting_fields as $skey =>  $fields): 
			$visibility = ($options[$skey]['authorized'] ? ' style="display: none;" ' : '');
			?>
			<div <?php print $visibility; ?> id="social_<?php print $skey; ?>">
				<h3><?php print $fields['social_name']; ?></h3>
				<p class="description"><?php print $fields['general_description']; ?></p>
				<div>
					<?php foreach($fields['fields'] as $fkey => $field): 
					$default_value = $setting_fields[$skey]['fields'][$field['name']]['default'];
					$option = (isset($options[$skey][$fkey]) ? $options[$skey][$fkey] : $default_value);
					if(pm_fb_hcs_set_field('type',$skey,$field['name']) != 'hidden'):
					?>
					<div>
						<label for="<?php print pm_fb_hcs_set_field('id',$skey,$field['name']); ?>"><?php print $field['label']; ?>:</label><br />
						<p class="description"><span><input type="<?php print pm_fb_hcs_set_field('type',$skey,$field['name']); ?>" name="<?php print pm_fb_hcs_set_field('name',$skey,$field['name']); ?>" id="<?php print pm_fb_hcs_set_field('id',$skey,$field['name']); ?>" value="<?php print $option; ?>" class="fb_hcs_setting_field" /></span>
						<span><?php print pm_fb_hcs_set_field('description',$skey,$field['name']); ?></span></p>
					</div>
					<?php else: ?>
					<div>
						<input type="<?php print pm_fb_hcs_set_field('type',$skey,$field['name']); ?>" name="<?php print pm_fb_hcs_set_field('name',$skey,$field['name']); ?>" id="<?php print pm_fb_hcs_set_field('id',$skey,$field['name']); ?>" value="<?php print $option; ?>" class="fb_hcs_setting_field" />
					</div>
					<?php endif; //Not HIdden ?>
					<?php endforeach; ?>
				</div>
			</div>
			<?php endforeach; ?>
			<?php submit_button( esc_html(__('Save Settings', 'pm-fb-hcsr')), 'primary', 'pm_fb_hcs_submit', false, array('id' => 'pm_fb_hcs_submit') ); ?>
		</form>
		
		<?php 
			$search_type = 'page';
			$fb_status = pm_fb_hcs_login_status();
			if( $fb_status ): //Facebook is Logged-in
			$hcs_results = array();
			$s_keyword = '';
			if( isset( $_POST['pm_fb_hcs_search_submit']) ):
				$access_token = $options['facebook']['token'];
				$limit = $options['settings']['query_limit'];
				$search_query = '';
				$search_type = (isset($_POST['pm_fb_hcs_search_type']) ? esc_html(trim($_POST['pm_fb_hcs_search_type'])) : 'page' );
				$s_keyword = rawurlencode(esc_html(trim($_POST['pm_fb_hcs_search_keyword'])));
				if($search_type == 'page') {
					$search_query = "search?q={$s_keyword}&type=page&fields=id,name,link,about,fan_count,picture&limit={$limit}";
				} elseif($search_type == 'group') {
					$search_query = "search?q={$s_keyword}&type=group&fields=id,name,privacy,picture{url}&limit={$limit}";
				}
				
				$hcs_results = pm_fb_hcs_api_call($search_query, $access_token);
			endif;
		?>
		<form id="pm_fb_hcs_search" name="pm_fb_hcs_search" method="POST" action="">
		<h2><?php esc_html(_e('Find Content on Facebook!','pm-fb-hcs')); ?></h2>
		<div class="form_wrapper">
			<label for="pm_fb_hcs_search_keyword"><?php esc_html(_e('Search Keyword','pm-fb-hcs')); ?></label>
			<input type="text" id="pm_fb_hcs_search_keyword" name="pm_fb_hcs_search_keyword" value="<?php print rawurldecode($s_keyword); ?>" placeholder="<?php esc_html(_e('wordpress, pluginmill','pm-fb-hcs')); ?>" />
		</div>
		<div class="form_wrapper">
			<h4 class="form-label"><?php esc_html(_e('Search Type','pm-fb-hcs')); ?></h4>
			<input <?php print ($search_type == 'page' ? 'checked' : ''); ?> type="radio" id="pm_fb_hcs_search_type-page" name="pm_fb_hcs_search_type" value="page"/>
			<label for="pm_fb_hcs_search_type-page"><?php esc_html(_e('Page','pm-fb-hcs')); ?></label>
			
			<input <?php print ($search_type == 'group' ? 'checked' : ''); ?> type="radio" id="pm_fb_hcs_search_type-group" name="pm_fb_hcs_search_type" value="group"/>
			<label for="pm_fb_hcs_search_type-group"><?php esc_html(_e('Group','pm-fb-hcs')); ?></label>
		</div>
		<div class="form_wrapper">
			<?php submit_button( esc_html(__('Search', 'pm-fb-hcs')), 'primary', 'pm_fb_hcs_search_submit', false, array('id' => 'pm_fb_hcs_search_submit') ); ?>
		</div>
		</form>
			<div id="pm_fb_hcs_results_wrapper">
			<?php 
			if( !empty($hcs_results->data) ): ?>
				<?php if($search_type == 'page'):
					pm_fb_hcs_format_result_pages($hcs_results);
				elseif($search_type == 'group'):
					pm_fb_hcs_format_result_groups($hcs_results);
				endif; ?>
			<?php else: ?>
				<?php if( isset( $_POST['pm_fb_hcs_search_submit']) ): ?>
					<p><?php esc_html(_e('Results are empty. please try other keywords','pm-fb-hcs')); ?></p>
				<?php endif; ?>
			<?php endif; // Results not Empty ?>
			</div>
		<?php endif; // Not is logged in ?>
	</div>	
	<?php
}