jQuery(document).ready(function($) {
	/*
		* Triggers Video to Play
	*/
	jQuery('#pm_fb_hcs_results_wrapper').on('click', 'div.video_link_wrapper a', function(a) {
		a.preventDefault();
		var video_link = jQuery(this).attr('data-video');
		jQuery(this).parent().html("<iframe src='"+video_link+"' width='450'></iframe>");
	});
	
	/*
		* Loads the Select content according to type
	*/
	jQuery('#pm_fb_hcs_results_wrapper table.form-table span.fb-hcs-btn.select').on('click', 'a', function(a) {
		a.preventDefault();
		jQuery("body").css("cursor", "progress");
		var id = jQuery(this).attr('data-id');
		var tabid = jQuery(this).attr('data-id');
		var name = jQuery(this).attr('data-name');
		var data = {
			action: 'pm_fb_hcs_get_post',
			type: 'feed',
			tabid: tabid,
			fid: id,
			name: name
		};

		// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
		jQuery.post(myAjax.ajaxurl, data, function(response) {
			jQuery('#pm_fb_hcs_results_wrapper').html(response);
			jQuery("body").css("cursor", "default");
		});
	});
	
	jQuery('div.wrap').on('click', 'span.fb-hcs-btn.view_photos a', function(a) {
		a.preventDefault();
		jQuery("body").css("cursor", "progress");
		var id = jQuery(this).attr('data-id');
		var tabid = jQuery(this).attr('data-tabid');
		var limit = jQuery(this).attr('data-count');
		var name = jQuery('#pm_fb_hcs_results_wrapper h2.selected-name').text();
		var data = {
			action: 'pm_fb_hcs_get_post',
			type: 'photos',
			tabid: tabid,
			fid: id,
			name: name,
			limit: limit
		};

		// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
		jQuery.post(myAjax.ajaxurl, data, function(response) {
			jQuery('#pm_fb_hcs_results_wrapper').html(response);
			jQuery("body").css("cursor", "default");
			jQuery('#tab_selections li a').removeClass('selected');
			jQuery('#tab_selections li a[data-type="albums"]').addClass('selected');
		});
	});
	
	jQuery('div.wrap').on('click', 'a.tab-link', function(a) {
		a.preventDefault();
		jQuery("body").css("cursor", "progress");
		var $this = jQuery('this');
		var id = jQuery(this).attr('data-id');
		var tabid = jQuery(this).attr('data-id');
		var name = jQuery('#pm_fb_hcs_results_wrapper h2.selected-name').text();
		var type = jQuery(this).attr('data-type');
		var data = {
			action: 'pm_fb_hcs_get_post',
			type: type,
			tabid: tabid,
			fid: id,
			name: name
		};
		// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
		jQuery.post(myAjax.ajaxurl, data, function(response) {
			jQuery('#pm_fb_hcs_results_wrapper').html(response);
			jQuery('#tab_selections li a').removeClass('selected');
			jQuery('#tab_selections li a[data-type="'+type+'"]').addClass('selected');
			jQuery("body").css("cursor", "default");
		});
	});
	
	
	/*
		* Trigger Add new Post Type
	*/
	if (typeof(Storage) !== "undefined") {
		
		jQuery('div.wrap').on('click', 'div.publish_content_wrapper span', function(a) {
			a.preventDefault();
			jQuery(this).parent().find('select').fadeToggle();
		});
		
		jQuery('div.wrap').on('change', 'div.publish_content_wrapper select', function(a) {
			a.preventDefault();
			var row = jQuery(this).parent().attr('data-class');
			var link = jQuery(this).val();
			var html = jQuery('table.form-table tr.'+row+' div.post_content_wrapper').html();
			localStorage.setItem("hcs_new_content", html);
			window.location.href = link;
		});
	} else {
		alert('Sorry! No Web Storage support.. You will not be able to use the Publish to Content Type');
	}
	
	/*
		* Triggers Sorting
	*/
	jQuery('div.wrap').on('change', '#result_sorting select', function() {
		var dtype = jQuery(this).find(':selected').attr('data-type');
		var dorder = jQuery(this).find(':selected').attr('data-sort');
		console.log(dtype);
		console.log(dorder);
		tinysort('table.form-table>tbody>tr',{data: dtype, order: dorder});
	});
	
	
	
	
	
	
});

